'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (mapStateToProps, mapDispatchToProps) {
  return function (Component) {
    var _class, _temp;

    return _temp = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class(props, context, updater) {
        _classCallCheck(this, _class);

        var reduxStore = void 0;
        if (context && context.store) reduxStore = context.store;else if (props && props.store) reduxStore = props.store;

        var mergedProps = void 0;
        if (reduxStore) {
          mergedProps = mergeProps(reduxStore, props, mapStateToProps, mapDispatchToProps);
        } else {
          mergedProps = props;
        }

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(_class).call(this, mergedProps, context, updater));

        _this._reactReduxInitialized = false;


        _this._mergedProps = mergedProps;
        _this._reduxStore = reduxStore;
        _this._reactReduxInitialized = true;
        return _this;
      }

      _createClass(_class, [{
        key: '_reduxUpdate',
        value: function _reduxUpdate(nextProps) {
          this._mergedProps = _extends({}, this._mergedProps, nextProps);
          _get(Object.getPrototypeOf(_class.prototype), 'forceUpdate', this).call(this);
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          addSubscription(this, this._reduxStore, Component, mapStateToProps, mapDispatchToProps);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'componentDidMount', this) === 'function') _get(Object.getPrototypeOf(_class.prototype), 'componentDidMount', this).call(this);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          removeSubscription(this, this._reduxStore);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'componentWillUnmount', this) === 'function') _get(Object.getPrototypeOf(_class.prototype), 'componentWillUnmount', this).call(this);
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
          nextProps = mergeProps(this._reduxStore, nextProps, mapStateToProps, mapDispatchToProps);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'componentWillUpdate', this) === 'function') _get(Object.getPrototypeOf(_class.prototype), 'componentWillUpdate', this).call(this, nextProps, nextState);
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
          nextProps = mergeProps(this._reduxStore, nextProps, mapStateToProps, mapDispatchToProps);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'shouldComponentUpdate', this) === 'function') {
            return _get(Object.getPrototypeOf(_class.prototype), 'shouldComponentUpdate', this).call(this, nextProps, nextState);
          }
          return true;
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          nextProps = mergeProps(this._reduxStore, nextProps, mapStateToProps, mapDispatchToProps);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'componentWillReceiveProps', this) === 'function') _get(Object.getPrototypeOf(_class.prototype), 'componentWillReceiveProps', this).call(this, nextProps);
        }
      }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps) {
          nextProps = mergeProps(this._reduxStore, nextProps, mapStateToProps, mapDispatchToProps);
          if (typeof _get(Object.getPrototypeOf(_class.prototype), 'componentWillUpdate', this) === 'function') _get(Object.getPrototypeOf(_class.prototype), 'componentWillUpdate', this).call(this, nextProps);
        }
      }, {
        key: 'props',
        get: function get() {
          if (!this._reactReduxInitialized) return undefined;
          return this._mergedProps;
        },
        set: function set(values) {
          this._mergedProps = _extends({}, this._mergedProps, values);
        }
      }]);

      return _class;
    }(Component), _class.contextTypes = _extends({ store: _storeShape2.default }, Component.contextTypes), _class.propTypes = _extends({ store: _storeShape2.default }, Component.contextTypes), _temp;
  };
};

var _shallowEqual = require('./utils/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _storeShape = require('./utils/storeShape');

var _storeShape2 = _interopRequireDefault(_storeShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var subscriptions = { stores: [] };

function subscribe(store) {
  var state = store.store.getState();
  for (var i = 0, len = store.components.length; i < len; ++i) {
    var _store$components$i = store.components[i];
    var instance = _store$components$i.instance;
    var component = _store$components$i.component;

    if (component.mapStateToProps) {
      var componentCurrentProps = component.mapStateToProps(instance.props);
      var componentNextProps = component.mapStateToProps(state);
      if (!(0, _shallowEqual2.default)(componentCurrentProps, componentNextProps)) {
        instance._reduxUpdate(componentNextProps);
      }
    }
  }
}

function initStore(store) {
  var finalStore = void 0;
  for (var i = 0, len = subscriptions.stores.length; i < len; ++i) {
    if (store === subscriptions.stores[i].store) {
      finalStore = subscriptions.stores[i];
      break;
    }
  }
  if (!finalStore) {
    finalStore = { store: store, components: [] };
    store.subscribe(subscribe.bind(null, finalStore));
    subscriptions.stores.push(finalStore);
  }
  return finalStore;
}

function addSubscription(instance, store, component, mapStateToProps, mapDispatchToProps) {
  store = initStore(store);
  store.components.push({
    instance: instance,
    component: component,
    mapStateToProps: typeof mapStateToProps === 'function' ? mapStateToProps : undefined,
    mapDispatchToProps: typeof mapDispatchToProps === 'function' ? mapDispatchToProps : undefined
  });
}

function removeSubscription(instance, store) {
  store = initStore(store);
  var index = void 0;
  for (var i = 0, len = store.components.length; i < len; ++i) {
    if (store.components[i].instance === instance) {
      index = i;
      break;
    }
  }
  if (index !== undefined) {
    store.components = [].concat(_toConsumableArray(store.components.slice(0, index)), _toConsumableArray(store.components.slice(index + 1)));
  }
}

function mergeProps(store, props, mapStateToProps, mapDispatchToProps) {
  var mergedProps = _extends({}, props);
  if (mapStateToProps) {
    mergedProps = _extends({}, mergedProps, mapStateToProps(store.getState()));
  }
  if (mapDispatchToProps) {
    mergedProps = _extends({}, mergedProps, mapDispatchToProps(store.dispatch));
  }
  return mergedProps;
}